Box:				; (D,E)-(H,L)
 ld bc,VirtScr
 push de
 ld d,h
 call FLine			; (h,e)-(h,l)
 pop de
 push de
 ld e,l
 call FLine			; (d,l)-(h,l)
 pop de
 push hl
 ld l,e
 call FLine			; (d,e)-(h,e)
 pop hl
 push hl
 ld h,d
 call FLine			; (d,e)-(d,l)
 pop hl
 ret
  
; PutSpriteS -- VirtScr, clips (0, 0)-(127, 63)
PutSpriteS:		 ; BC = x,y  HL = sprite
 push bc
 push de
 push hl
 push ix
 ld a,$FF
 ld (clipmask),a
 bit 7,b
 jr z,PSCS_CheckRightClip
 ld a,b
 cp 249
 jr c,EndPPSS
 neg
 push bc
 ld b,a
 ld a,$FF
PSCS_LeftClip:
 srl a
 djnz PSCS_LeftClip
 pop bc
 res 7,b
 dec c
 ld (clipmask),a
 jr PSCS_CheckBotClip
PSCS_CheckRightClip
 ld a,b
 sub 127-6
 jr c,PSCS_CheckBotClip
 push bc
 ld b,a
 inc b
 ld a,$FF
PSCS_RightClip:
 add a,a
 djnz PSCS_RightClip
 ld (clipmask),a
 pop bc
PSCS_CheckBotClip:
 ld a,8
 ld (rows2put),a
 bit 7,c
 jr nz,PSCS_CheckTopClip
 bit 6,c
 jr nz,EndPSS
 ld a,64
 sub c
 cp 8
 jr nc,PSCS_ClippingDone
 ld (rows2put),a
 jr PSCS_ClippingDone
PSCS_CheckTopClip:
 ld a,c
 cp 249
EndPPSS:
 jr c,EndPSS
 push bc
 neg
 ld b,a
 sub 8
 neg
 ld (rows2put),a
PSCS_TopClip:
 inc hl
 inc de
 djnz PSCS_TopClip
 pop bc
 ld c,0
PSCS_ClippingDone:
 push hl
 pop ix
 ld a,(rows2put)
 push af
 call FIND_PIXEL
 ld de,VirtScr
 add hl,de
 ld d,a
 pop bc
PSCS_PutRow:
 push bc
 push hl
 ld a,(clipmask)
 ld e,a
 ld b,8
 ld c,(ix)
 inc ix
PSCS_PutCol:
 push bc
 rlc e
 jr nc,PSCS_NextBit
 ld a,d
 rlc c
 jr nc,PSCS_NextBit; jr c,PSCS_BitOn
; cpl
; and (hl)
; ld (hl),a
; jr PSCS_NextBit
PSCS_BitOn:
 or (hl)
 ld (hl),a
PSCS_NextBit:
 rrc d
 jr nc,PSCS_SSB
 inc hl
PSCS_SSB:
 pop bc
 rlc c
 djnz PSCS_PutCol
 pop hl
 ld bc,16
 add hl,bc
 pop bc
 djnz PSCS_PutRow
EndPSS:
 pop ix
 pop hl
 pop de
 pop bc
 ret
